/* Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator */
/* From input file "control.pas" */


#include <p2c/p2c.h>


#define CONTROL_G
#include "control.h"


#ifndef UTILITY_H
#include "utility.h"
#endif


typedef enum {
  noSuchFeature, FmultiFile, FsplitShortcut, FnewWordShortcut, FdoChords,
  FdoUptext, FdoLyrics, FunbeamVocal, FhideBlindSlurs, FuptextOnRests,
  FsolfaNoteNames, FpedanticWarnings, FignoreErrors, FinstrumentNames,
  FbeVerbose, FdebugMode
} feature;

typedef struct Tfeature {
  Char tag[31];
  boolean active, changed;
} Tfeature;


#define firstFeature    FmultiFile
#define lastFeature     FdebugMode


Static Tfeature feat[16] = {
  { "", false, false },
  { "multiFile", true, false },
  { "splitShortcut", true, false },
  { "newWordShortcut", true, false },
  { "doChords", true, false },
  { "doUptext", true, false },
  { "doLyrics", true, false },
  { "unbeamVocal", true, false },
  { "hideBlindSlurs", true, false },
  { "uptextOnRests", true, false },
  { "solfaNoteNames", false, false },
  { "pedanticWarnings", false, false },
  { "ignoreErrors", false, false },
  { "instrumentNames", false, false },
  { "beVerbose", false, false },
  { "debugMode", false, false }
};


void printFeatures(boolean anyway)
{
  feature i;
  Tfeature *WITH;

  for (i = firstFeature; i <= lastFeature; i = (feature)((long)i + 1)) {
    WITH = &feat[(long)i];
    if (WITH->changed || anyway)
      printf("%s = %s\n", WITH->tag, WITH->active ? " TRUE" : "FALSE");
  }
}


Static feature featureNamed(Char *s)
{
  feature i;

  for (i = firstFeature; i <= lastFeature; i = (feature)((long)i + 1)) {
    if (equalsIgnoreCase(s, feat[(long)i].tag))
      return i;
  }
  return noSuchFeature;
}


boolean setFeature(Char *which, boolean val)
{
  boolean Result = false;
  feature f;
  Tfeature *WITH;

  f = featureNamed(which);
  if (f != noSuchFeature) {
    WITH = &feat[(long)f];
    WITH->active = val;
    WITH->changed = true;
    Result = true;
  }
  if (f == FdebugMode && val)
    feat[(long)FbeVerbose].active = true;
  if (f == FbeVerbose && !val)
    feat[(long)FdebugMode].active = false;
  return Result;
}


void mtxLevel(Char *level)
{
  if (strcmp(level, "0.55") >= 0)
    feat[(long)FsplitShortcut].active = false;
  if (strcmp(level, "0.55") < 0) {
    feat[(long)FmultiFile].active = false;
    feat[(long)FnewWordShortcut].active = false;
  }
}


/* Feature functions.  To add a new feature "newFeature":
   1. Insert a new value "FnewFeature" in the declaration of type "feature".
   2. Insert an entry for it in array "feat".
   3. Copy the template below and change "FEATURE" into "newFeature".
   4. (Optional) Insert code into "mtxLevel" to enable/disable the feature.

function FEATURE: boolean;
begin FEATURE := feat[FFEATURE].active end;
*/

boolean beVerbose(void)
{
  return (feat[(long)FbeVerbose].active);
}


boolean debugMode(void)
{
  return (feat[(long)FdebugMode].active);
}


boolean instrumentNames(void)
{
  return (feat[(long)FinstrumentNames].active);
}


boolean hideBlindSlurs(void)
{
  return (feat[(long)FhideBlindSlurs].active);
}


boolean doLyrics(void)
{
  return (feat[(long)FdoLyrics].active);
}


boolean ignoreErrors(void)
{
  return (feat[(long)FignoreErrors].active);
}


boolean pedanticWarnings(void)
{
  return (feat[(long)FpedanticWarnings].active);
}


boolean solfaNoteNames(void)
{
  return (feat[(long)FsolfaNoteNames].active);
}


boolean uptextOnRests(void)
{
  return (feat[(long)FuptextOnRests].active);
}


boolean unbeamVocal(void)
{
  return (feat[(long)FunbeamVocal].active);
}


boolean doChords(void)
{
  return (feat[(long)FdoChords].active);
}


boolean doUptext(void)
{
  return (feat[(long)FdoUptext].active);
}


boolean newWordShortcut(void)
{
  return (feat[(long)FnewWordShortcut].active);
}


boolean splitShortcut(void)
{
  return (feat[(long)FsplitShortcut].active);
}


boolean multiFile(void)
{
  return (feat[(long)FmultiFile].active);
}





/* End. */
